package gregapi.block.multitileentity.example;

import static gregapi.data.CS.*;
import static org.lwjgl.opengl.GL11.*;
import static org.lwjgl.opengl.GL12.GL_RESCALE_NORMAL;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetBlockHardness;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetCollisionBoundingBoxFromPool;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetComparatorInputOverride;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetExplosionResistance;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetFireSpreadSpeed;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetFlammability;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_GetSelectedBoundingBoxFromPool;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnBlockActivated;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnPlaced;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnRegistrationClient;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_OnToolClick;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataByte;
import gregapi.block.multitileentity.IMultiTileEntity.IMTE_SyncDataByteArray;
import gregapi.block.multitileentity.*;
import gregapi.data.CS.ModIDs;
import gregapi.gui.ContainerClient;
import gregapi.gui.ContainerCommon;
import gregapi.network.INetworkHandler;
import gregapi.network.IPacket;
import gregapi.network.packets.data.PacketSyncDataByte;
import gregapi.network.packets.ids.PacketSyncDataByteArrayAndIDs;
import gregapi.render.ITexture;
import gregapi.tileentity.ITileEntitySurface;
import gregapi.tileentity.TileEntityBase5;
import gregapi.util.UT;

import java.util.HashMap;
import java.util.Map;

import net.minecraft.block.Block;
import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.client.renderer.tileentity.TileEntityRendererDispatcher;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.AxisAlignedBB;
import net.minecraft.util.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.StatCollector;
import net.minecraft.world.World;

import org.lwjgl.opengl.GL11;

import cpw.mods.fml.client.registry.ClientRegistry;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

/**
 * @author Gregorius Techneticies
 * 
 * An example implementation of a Chest with my MultiTileEntity System.
 */
public class MultiTileEntityChest extends TileEntityBase5 implements ITileEntitySurface, IMTE_OnRegistrationClient, IMTE_SyncDataByte, IMTE_GetFlammability, IMTE_GetFireSpreadSpeed, IMTE_SyncDataByteArray, IMTE_GetExplosionResistance, IMTE_GetComparatorInputOverride, IMTE_GetSelectedBoundingBoxFromPool, IMTE_GetCollisionBoundingBoxFromPool, IMTE_GetBlockHardness, IMTE_OnPlaced, IMTE_OnBlockActivated, IMTE_OnToolClick {
	protected int mRGBa = UNCOLORED;
	protected byte mFacing = 3, mUsingPlayers = 0, oUsingPlayers = 0;
	protected float mLidAngle = 0, oLidAngle = 0, mHardness = 3.0F, mResistance = 3.0F;
	
	/** Gets supplied via Default NBT. */
	protected String mTextureName = "";
	
	public MultiTileEntityChest() {/**/}
	
    @Override
    public void readFromNBT2(NBTTagCompound aNBT) {
        super.readFromNBT2(aNBT);
        if (aNBT.hasKey(NBT_COLOR)) mRGBa = aNBT.getInteger(NBT_COLOR);
        if (aNBT.hasKey(NBT_FACING)) mFacing = aNBT.getByte(NBT_FACING);
        if (aNBT.hasKey("gt.texture")) mTextureName = aNBT.getString("gt.texture");
        if (aNBT.hasKey(NBT_HARDNESS)) mHardness = aNBT.getFloat(NBT_HARDNESS);
        if (aNBT.hasKey(NBT_RESISTANCE)) mResistance = aNBT.getFloat(NBT_RESISTANCE);
    }
    
    @Override
    public void writeToNBT2(NBTTagCompound aNBT) {
        super.writeToNBT2(aNBT);
        aNBT.setByte(NBT_FACING, mFacing);
        aNBT.setInteger(NBT_COLOR, mRGBa);
    }
    
    @Override
    public boolean onTickCheck(long aTimer) {
    	return mUsingPlayers != oUsingPlayers;
    }
    
	@Override
	public IPacket getClientDataPacket(boolean aSendAll) {
		if (aSendAll) {
			short[] tRGBa = UT.Code.getRGBaArray(mRGBa);
			return new PacketSyncDataByteArrayAndIDs(xCoord, yCoord, zCoord, getMultiTileEntityRegistryID(), getMultiTileEntityID(), mFacing, oUsingPlayers=mUsingPlayers, (byte)getSizeInventory(), (byte)tRGBa[0], (byte)tRGBa[1], (byte)tRGBa[2]);
		}
		return new PacketSyncDataByte(xCoord, yCoord, zCoord, oUsingPlayers=mUsingPlayers);
	}
	
	@Override
	public boolean onPlaced(ItemStack aStack, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ, byte aSide, float aHitX, float aHitY, float aHitZ) {
        switch(MathHelper.floor_double(((aPlayer.rotationYaw * 4F) / 360F) + 0.5D) & 3) {case 0: mFacing = 2; break; case 1: mFacing = 5; break; case 2: mFacing = 3; break; case 3: mFacing = 4; break;}
		return true;
	}
	
    @Override
    public void onTick(long aTimer, boolean aIsServerSide) {
    	super.onTick(aTimer, aIsServerSide);
        if (isServerSide() && mUsingPlayers > 0 && aTimer % 1200 == 0) {
            mUsingPlayers = 0;
            for (Object tPlayer : worldObj.getEntitiesWithinAABB(EntityPlayer.class, AxisAlignedBB.getBoundingBox(xCoord - 5.0F, yCoord - 5.0F, zCoord - 5.0F, xCoord + 1 + 5.0F, yCoord + 1 + 5.0F, zCoord + 1 + 5.0F))) if (tPlayer instanceof EntityPlayer && ((EntityPlayer)tPlayer).openContainer instanceof MultiTileEntityGUICommonChest && ((MultiTileEntityGUICommonChest)((EntityPlayer)tPlayer).openContainer).mTileEntity == this) mUsingPlayers++;
        }
        oLidAngle = mLidAngle;
        if (mUsingPlayers > 0 && mLidAngle == 0.0F) worldObj.playSoundEffect(xCoord + 0.5D, yCoord + 0.5D, zCoord + 0.5D, "random.chestopen", 0.5F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
        if (mUsingPlayers == 0 && mLidAngle > 0.0F || mUsingPlayers > 0 && mLidAngle < 1.0F) {
            if (mUsingPlayers > 0) mLidAngle += 0.1F; else mLidAngle -= 0.1F;
            if (mLidAngle > 1.0F) mLidAngle = 1.0F; else if (mLidAngle < 0.0F) mLidAngle = 0.0F;
            if (mLidAngle < 0.5F && oLidAngle >= 0.5F) worldObj.playSoundEffect(xCoord + 0.5D, yCoord + 0.5D, zCoord + 0.5D, "random.chestclosed", 0.5F, worldObj.rand.nextFloat() * 0.1F + 0.9F);
        }
    }
    
	@Override
	public long onToolClick(String aTool, long aRemainingDurability, Entity aPlayer, IInventory aPlayerInventory, boolean aSneaking, ItemStack aStack, byte aSide, float aHitX, float aHitY, float aHitZ) {
		if (worldObj.isRemote) return 0;
		if (aTool.equals(TOOL_wrench)) {byte aTargetSide = UT.Code.getSideWrenching(aSide, aHitX, aHitY, aHitZ); if (aTargetSide > 1) {mFacing = aTargetSide; updateClientData(); causeBlockUpdate(); return 10000;}}
		return 0;
	}
	
    @Override
	public boolean onBlockActivated(EntityPlayer aPlayer, byte aSide, float aHitX, float aHitY, float aHitZ) {
		if (!worldObj.isSideSolid(xCoord, yCoord + 1, zCoord, FORGE_DIR[SIDE_BOTTOM]) && !worldObj.isRemote && isUseableByPlayer(aPlayer)) openGUI(aPlayer);
		return true;
	}
    
	@Override public int getFireSpreadSpeed(byte aSide) {return 0;}
	@Override public int getFlammability(byte aSide) {return 0;}
	@Override public boolean canDrop(int aInventorySlot) {return true;}
	@Override public String getTileEntityName() {return "gt.multitileentity.chest";}
    @Override public void openInventory () {mUsingPlayers++;}
    @Override public void closeInventory() {mUsingPlayers--;}
	@Override public float getExplosionResistance(Entity aExploder, double aExplosionX, double aExplosionY, double aExplosionZ) {return mResistance;}
	@Override public float getBlockHardness() {return mHardness;}
	@Override public int getComparatorInputOverride(byte aSide) {return Container.calcRedstoneFromInventory(this);}
	@Override public ITexture getTexture(Block aBlock, int aRenderPass, byte aSide) {return null;}
	@Override public int getRenderPasses(Block aBlock, byte aSide) {return 0;}
	@Override public boolean renderBlock(Block aBlock, RenderBlocks aRenderer) {return true;}
	
	@Override
	public boolean renderItem(Block aBlock, RenderBlocks aRenderer) {
        TileEntityRendererDispatcher.instance.renderTileEntityAt(this, 0.0D, 0.0D, 0.0D, 0.0F);
		return true;
	}
	
	@SideOnly(Side.CLIENT)
	private MultiTileEntityRendererChest mRenderer;
	
	@Override
	@SideOnly(Side.CLIENT)
	public void onRegistrationClient(MultiTileEntityRegistry aRegistry) {
		if (mRenderer == null) ClientRegistry.bindTileEntitySpecialRenderer(getClass(), mRenderer = new MultiTileEntityRendererChest());
		mRenderer.mResources.put(mTextureName, new ResourceLocation[] {new ResourceLocation(ModIDs.GT, TEX_DIR_MODEL + aRegistry.mNameInternal + "/" + mTextureName + ".colored.png"), new ResourceLocation(ModIDs.GT, TEX_DIR_MODEL + aRegistry.mNameInternal + "/" + mTextureName + ".plain.png")});
	}
	
	@Override public boolean receiveDataByte(byte aData, INetworkHandler aNetworkHandler) {mUsingPlayers = aData; worldObj.markBlockForUpdate(xCoord, yCoord, zCoord); return true;}
	
	@Override
	public boolean receiveDataByteArray(byte[] aData, INetworkHandler aNetworkHandler) {
		mFacing = (byte)(aData[0] & 7);
		mUsingPlayers = aData[1];
		if (UT.Code.unsignB(aData[2]) != getSizeInventory()) setInventory(new ItemStack[UT.Code.unsignB(aData[2])]);
		mRGBa = UT.Code.getRGBInt(new short[] {UT.Code.unsignB(aData[3]), UT.Code.unsignB(aData[4]), UT.Code.unsignB(aData[5])});
		return true;
	}
	
    private static final float minX = 0.0625F, minY = 0F, minZ = 0.0625F, maxX = 0.9375F, maxY = 0.875F, maxZ = 0.9375F;
    @Override public AxisAlignedBB getCollisionBoundingBoxFromPool() {return AxisAlignedBB.getBoundingBox(xCoord + minX, yCoord + minY, zCoord + minZ, xCoord + maxX, yCoord + maxY, zCoord + maxZ);}
    @Override public AxisAlignedBB getSelectedBoundingBoxFromPool () {return AxisAlignedBB.getBoundingBox(xCoord + minX, yCoord + minY, zCoord + minZ, xCoord + maxX, yCoord + maxY, zCoord + maxZ);}
    @Override public boolean setBlockBounds(Block aBlock, int aRenderPass, byte aSide) {aBlock.setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ); return true;}
	@Override public float getSurfaceSize    		(byte aSide) {return 0.875F;}
	@Override public float getSurfaceSizeAttachable	(byte aSide) {return 0.875F;}
	@Override public float getSurfaceDistance		(byte aSide) {return aSide > 1 ? 0.0625F : aSide == 1 ? 0.125F : 0;}
	@Override public boolean isSurfaceSolid  		(byte aSide) {return false;}
	@Override public boolean isSurfaceOpaque 		(byte aSide) {return false;}
	
	@Override public Object getGUIClient(int aGUIID, EntityPlayer aPlayer) {return new MultiTileEntityGUIClientChest(aPlayer.inventory, this);}
	@Override public Object getGUIServer(int aGUIID, EntityPlayer aPlayer) {return new MultiTileEntityGUICommonChest(aPlayer.inventory, this);}
	
	@SideOnly(Side.CLIENT)
	public static class MultiTileEntityRendererChest extends TileEntitySpecialRenderer {
	    private static final MultiTileEntityModelChest sModel = new MultiTileEntityModelChest();
		public final Map<String, ResourceLocation[]> mResources = new HashMap<String, ResourceLocation[]>();
		
		@Override
		public void renderTileEntityAt(TileEntity aTileEntity, double aX, double aY, double aZ, float aPartialTick) {
	        if (aTileEntity instanceof MultiTileEntityChest) {
	        	ResourceLocation[] tLocation = mResources.get(((MultiTileEntityChest)aTileEntity).mTextureName);
		        bindTexture(tLocation[0]);
		        glPushMatrix();
		        glEnable(GL_RESCALE_NORMAL);
		        short[] tRGBa = UT.Code.getRGBaArray(((MultiTileEntityChest)aTileEntity).mRGBa);
		        glColor4f(tRGBa[0] / 256.0F, tRGBa[1] / 256.0F, tRGBa[2] / 256.0F, 1.0F);
		        glTranslatef((float)aX, (float)aY + 1.0F, (float)aZ + 1.0F);
		        glScalef(1.0F, -1.0F, -1.0F);
		        glTranslatef(0.5F, 0.5F, 0.5F);
		        switch(((MultiTileEntityChest)aTileEntity).mFacing) {
		        case  2: glRotatef(180, 0.0F, 1.0F, 0.0F); break;
		        case  4: glRotatef( 90, 0.0F, 1.0F, 0.0F); break;
		        case  5: glRotatef(-90, 0.0F, 1.0F, 0.0F); break;
		        default: glRotatef(  0, 0.0F, 1.0F, 0.0F); break;
		        }
		        glTranslatef(-0.5F, -0.5F, -0.5F);
		        float tLidAngle = 1.0F - (((MultiTileEntityChest)aTileEntity).oLidAngle + (((MultiTileEntityChest)aTileEntity).mLidAngle - ((MultiTileEntityChest)aTileEntity).oLidAngle) * aPartialTick);
		        tLidAngle = -(((1.0F - tLidAngle*tLidAngle*tLidAngle) * 3.141593F) / 2.0F);
		        sModel.render(tLidAngle);
		        glDisable(GL_RESCALE_NORMAL);
		        glPopMatrix();
		        glEnable(GL_RESCALE_NORMAL);
		        glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		        
		        bindTexture(tLocation[1]);
		        glPushMatrix();
		        glTranslatef((float)aX, (float)aY + 1.0F, (float)aZ + 1.0F);
		        glScalef(1.0F, -1.0F, -1.0F);
		        glTranslatef(0.5F, 0.5F, 0.5F);
		        switch(((MultiTileEntityChest)aTileEntity).mFacing) {
		        case  2: glRotatef(180, 0.0F, 1.0F, 0.0F); break;
		        case  4: glRotatef( 90, 0.0F, 1.0F, 0.0F); break;
		        case  5: glRotatef(-90, 0.0F, 1.0F, 0.0F); break;
		        default: glRotatef(  0, 0.0F, 1.0F, 0.0F); break;
		        }
		        glTranslatef(-0.5F, -0.5F, -0.5F);
		        sModel.render(tLidAngle);
		        glDisable(GL_RESCALE_NORMAL);
		        glPopMatrix();
                glEnable(GL_RESCALE_NORMAL);
	        }
	    }
	}
	
	@SideOnly(Side.CLIENT)
	public static class MultiTileEntityModelChest extends ModelBase {
	    private final ModelRenderer mLid, mBottom, mKnob;
	    
	    public MultiTileEntityModelChest() {
	    	mLid = (new ModelRenderer(this, 0, 0)).setTextureSize(64, 64);
	        mLid.addBox(0.0F, -5.0F, -14.0F, 14, 5, 14, 0.0F);
	        mLid.rotationPointX =  1.0F;
	        mLid.rotationPointY =  7.0F;
	        mLid.rotationPointZ = 15.0F;
	        mKnob = (new ModelRenderer(this, 0, 0)).setTextureSize(64, 64);
	        mKnob.addBox(-1.0F, -2.0F, -15.0F, 2, 4, 1, 0.0F);
	        mKnob.rotationPointX =  8.0F;
	        mKnob.rotationPointY =  7.0F;
	        mKnob.rotationPointZ = 15.0F;
	        mBottom = (new ModelRenderer(this, 0, 19)).setTextureSize(64, 64);
	        mBottom.addBox(0.0F, 0.0F, 0.0F, 14, 10, 14, 0.0F);
	        mBottom.rotationPointX = 1.0F;
	        mBottom.rotationPointY = 6.0F;
	        mBottom.rotationPointZ = 1.0F;
	    }
	    
	    public void render(float aLidAngle) {
	        mKnob.rotateAngleX = mLid.rotateAngleX = aLidAngle;
	        mLid.render(0.0625F);
	        mKnob.render(0.0625F);
	        mBottom.render(0.0625F);
	    }
	}
	
	public class MultiTileEntityGUICommonChest extends ContainerCommon {
	    public MultiTileEntityGUICommonChest(InventoryPlayer aInventoryPlayer, IInventory aTileEntity) {
	    	super(aInventoryPlayer, aTileEntity);
            addSlots(aInventoryPlayer);
	    }
	    
		@Override
	    public void addSlots(InventoryPlayer aInventoryPlayer) {
			int tSize = mTileEntity.getSizeInventory(), tRows = tSize/9 + (tSize%9==0?0:1);
            for (int y = 0, i = 0; y < tRows; y++) for (int x = 0; x < 9 && i < tSize; x++) addSlotToContainer(new Slot(mTileEntity, i++, 8 + x * 18, 18 + y * 18));
            if (doesBindPlayerInventory()) bindPlayerInventory(aInventoryPlayer, 103+(tRows-4)*18);
	    }
		
		@Override public int getSlotCount() {return mTileEntity.getSizeInventory();}
		@Override public int getShiftClickSlotCount() {return mTileEntity.getSizeInventory();}
	}
	
	@SideOnly(Side.CLIENT)
	public class MultiTileEntityGUIClientChest extends ContainerClient {
	    private int mRows;
	    
	    public MultiTileEntityGUIClientChest(InventoryPlayer aInventoryPlayer, IInventory aTileEntity) {
	    	super(new MultiTileEntityGUICommonChest(aInventoryPlayer, aTileEntity), RES_PATH_GUI + "chests/" + aTileEntity.getSizeInventory() + ".png");
	        allowUserInput = false;
	        mRows = mContainer.mTileEntity.getSizeInventory() / 9 + (mContainer.mTileEntity.getSizeInventory() % 9 == 0 ? 0 : 1);
	        ySize = 114 + mRows * 18;
	    }
	    
	    @Override
		protected void drawGuiContainerForegroundLayer(int p_146979_1_, int p_146979_2_) {
	        fontRendererObj.drawString(mContainer.mTileEntity.getInventoryName(), 8, 6, 4210752);
	        fontRendererObj.drawString(StatCollector.translateToLocal("container.inventory"), 8, ySize - 94, 4210752);
	    }
	    
	    @Override
		protected void drawGuiContainerBackgroundLayer(float par1, int par2, int par3) {
	    	super.drawGuiContainerBackgroundLayer(par1, par2, par3);
	        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
	        int k = (width - xSize) / 2;
	        int l = (height - ySize) / 2;
	        drawTexturedModalRect(k, l, 0, 0, xSize, mRows * 18 + 17);
	        drawTexturedModalRect(k, l + mRows * 18 + 17, 0, 126, xSize, 96);
	    }
	}
}